
package ar.charlycimino.ejemplos;

import java.util.Scanner;

/**
 *
 * @author Charly Cimino
 * Aprendé más Java en mi canal: https://www.youtube.com/c/CharlyCimino
 * Encontrá más código en mi repo de GitHub: https://github.com/CharlyCimino
 */
public class EjercicioIntegrador17 {
    
    public static void main(String[] args) {
        // Algunos números perfectos: 6, 28, 496, 8128...
        int n = leerEnteroEntre("Ingresá un número natural", 1, Integer.MAX_VALUE);
        informarSiEsPerfecto(n);
    } // Cierre de main
    
    static int leerEnteroEntre(String mensaje, int min, int max) {
        Scanner input = new Scanner(System.in);
        System.out.print(mensaje + ": ");
        int x = Integer.parseInt( input.nextLine() ); 
        while (x < min || x > max) {
            System.out.print("ERROR. " + mensaje + ": ");
            x = Integer.parseInt( input.nextLine() ); 
        }
        return x;
    }
    
    static void informarSiEsPerfecto(int num) {
        if ( esPerfecto(num) ) {
            System.out.println("El número " + num + " es perfecto");
        } else {
            System.out.println("El número " + num + " NO es perfecto");
        }
    }

    static boolean esPerfecto(int num) {        
        return sumatoriaDeDivisoresPropios(num) == num;
    }
    
    static boolean esMultiplo(int a, int b) {
        return obtenerResto(a, b) == 0;
    }
    
    static int obtenerResto(int num1, int num2) {
        return num1 - num2 * (num1 / num2);
    }

    static int sumatoriaDeDivisoresPropios(int num) {
        int sumatoria = 0;
        int mitad = num / 2;
        for (int i = 1; i <= mitad; i++) {
            if (esMultiplo(num, i)) {
                sumatoria += i;
            }
        }
        return sumatoria;
    }
    

} // Cierre de clase
